include ( ../../../../buildcfg.pro )

TEMPLATE	= lib

CONFIG		= qt thread plugin opengl $${BUILDTYPE}

HEADERS		= src/Action.h \
                  src/ActionManager.h \
                  src/BadNormalRemover.h \
                  src/BoxSelector.h \
                  src/ColorModifier.h \
                  src/cQuaternion.h \
                  src/Deletor.h \
                  src/Help.h \
                  src/LocalParticleSimulation.h \
                  src/MemChecker.h \
                  src/Metric.h \
                  src/MLSScatterer.h \
                  src/MovingLeastSquares.h \
                  src/MovingLeastSquaresSmoother.h \
                  src/my_defs.h \
                  src/MyComparators.h \
                  src/NewOverload.h \
                  src/OutlierClassificationDialogImpl.h \
                  src/OutlierClassificator.h \
                  src/PlaneFit.h \
                  src/RandomNoise.h \
                  src/ScanTools.h \
                  src/ScanToolsBoxColorDialogImpl.h \
                  src/ScanToolsConfigurationDialogImpl.h \
                  src/ScanToolsDialogImpl.h \
                  src/ScanToolsGlobals.h \
                  src/Selector.h \
                  src/SurfelResizer.h \
                  src/UndoRedoSpecialisations.h

SOURCES		= src/Action.cpp \
                  src/ActionManager.cpp \
                  src/BadNormalRemover.cpp \
                  src/BoxSelector.cpp \
                  src/ColorModifier.cpp \
                  src/cQuaternion.cpp \
                  src/Deletor.cpp \
                  src/Help.cpp \
                  src/LocalParticleSimulation.cpp \
                  src/MemChecker.cpp \
                  src/Metric.cpp \
                  src/MLSScatterer.cpp \
                  src/MovingLeastSquares.cpp \
                  src/MovingLeastSquaresSmoother.cpp \
                  src/OutlierClassificationDialogImpl.cpp \
                  src/OutlierClassificator.cpp \
                  src/PlaneFit.cpp \
                  src/RandomNoise.cpp \
                  src/ScanTools.cpp \
                  src/ScanToolsBoxColorDialogImpl.cpp \
                  src/ScanToolsConfigurationDialogImpl.cpp \
                  src/ScanToolsDialogImpl.cpp \
                  src/ScanToolsGlobals.cpp \
                  src/Selector.cpp \
                  src/SurfelResizer.cpp \
                  src/UndoRedoSpecialisations.cpp

INTERFACES	= UI/HelpWidget.ui \
                  UI/OutlierClassificationWindow.ui \
                  UI/ScanToolsBoxColorWidget.ui \
                  UI/ScanToolsConfigurationWidget.ui \
                  UI/ScanToolsWidget.ui

TARGET		= ScanTools

INCLUDEPATH     += ${GSLDIR}/include

OBJECTS_DIR     = bin/linux/$${BUILDTYPE}

MOC_DIR		= bin/linux/$${BUILDTYPE}

DESTDIR		= ../../../../bin/linux/$${BUILDTYPE}/Tools

LIBS	       += -L../../../../bin/linux/$${BUILDTYPE} -L${GSLDIR}/lib -lCore -lUtilities -lDataTypes -lgsl -lgslcblas

QMAKE_POST_LINK = mkdir -p ../../../../bin/linux/$${BUILDTYPE}/Resources && \
                  cp \
                     Icons/ScanToolIcon.png \
                     Icons/ScanToolIcon_disabled.png \
                     Icons/SCT_DeleteIcon.png \
                     Icons/SCT_FalseNormalsIcon.png \
                     Icons/SCT_LPSIcon.png \
                     Icons/SCT_MarkIcon.png \
                     Icons/SCT_MLSIcon.png \
                     Icons/SCT_NoiseIcon.png \
                     Icons/SCT_OutlierIcon.png \
                     Icons/SCT_RecolorIcon.png \
                     Icons/SCT_ResizerIcon.png \
                     Icons/SCT_ScatterIcon.png \
                     Icons/SCT_TemplateIcon.png \
                     ../../../../bin/linux/$${BUILDTYPE}/Resources
