// Title:   MyComparators.h
// Created: Thu Sep 25 15:16:20 2003
// Authors: Simon Heinzle, Tim Weyrich
//
// Copyright (c) 2001, 2002, 2003, Computer Graphics Lab, ETH Zurich
//
// This file is part of the Pointshop3D system.
// See http://www.pointshop3d.com/ for more information.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later
// version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General
// Public License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place, Suite 330,
// Boston, MA 02111-1307 USA
// 
// Contact info@pointshop3d.com if any conditions of this
// licensing are not clear to you.
//

#ifndef __MYCOMPARATORS_H
#define __MYCOMPARATORS_H
/**
 * This file includes two comparators.
 *
 * @author Simon Heinzle
 * @version 1.0
 */

#include <stdio.h>
#include <qstring.h>
#include "../../../../Core/Scene/src/Scene.h"
#include "my_defs.h"

/**
 * struct MyObjectComparator
 *
 * functional object to compare two <code>Object</code>s
 */
struct MyObjectComparator
{
  bool operator()(const Object* o1, const Object* o2) const
  {
	//return o1<o2;
	return o1->getName().compare(o2->getName()) < 0;
  }
};

/**
 * struct MyObjectComparator
 *
 * functional object to compare two <code>tObjectInvTransformationPair</code>s
 */
struct MyObjectInvTransformationPairComparator
{
  bool operator()(const tObjectInvTransformationPair op1, const tObjectInvTransformationPair op2) const
  {
    return op1.object->getName().compare(op2.object->getName()) < 0;
  }
};



#endif
// Some Emacs-Hints -- please don't remove:
//
//  Local Variables:
//  mode:C++
//  tab-width:4
//  End:
