// Title:   NewOverload.h
// Created: Thu Sep 25 15:16:19 2003
// Authors: Simon Heinzle, Tim Weyrich
//
// Copyright (c) 2001, 2002, 2003, Computer Graphics Lab, ETH Zurich
//
// This file is part of the Pointshop3D system.
// See http://www.pointshop3d.com/ for more information.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later
// version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General
// Public License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place, Suite 330,
// Boston, MA 02111-1307 USA
// 
// Contact info@pointshop3d.com if any conditions of this
// licensing are not clear to you.
//

#ifndef __NEWOVERLOAD_H
#define __NEWOVERLOAD_H

#include "MemChecker.h"

inline void _MCnew(unsigned long ptr, unsigned int size, const char *file, int line) {
#ifdef _DEBUG
	MemChecker::getInstance()->AddTrack(ptr, size, file, line);
#endif
}

inline void _MCdelete(unsigned long ptr) {
#ifdef _DEBUG
	MemChecker::getInstance()->RemoveTrack((unsigned long)ptr);
#endif
}



#if 0
	/**
	 * new overloads for memchecking
	 */
	#ifdef _DEBUG
	inline void * __cdecl operator new(unsigned int size, 
									   const char *file, int line) {
		void *ptr = (void *)malloc(size);
		MemChecker::getInstance()->AddTrack((unsigned long)ptr, size, file, line);
		return(ptr);
	};

	inline void __cdecl operator delete(void *p) {
		MemChecker::getInstance()->RemoveTrack((unsigned long)p);
		free(p);
	};

	#endif

	#ifdef _DEBUG
	#define DEBUG_NEW new(__FILE__, __LINE__)
	#else
	#define DEBUG_NEW new
	#endif
	#define new DEBUG_NEW

	/** 
	 * new[] overloads
	 */

	#ifdef _DEBUG
	inline void * __cdecl operator new[](unsigned int size, const char *file, int line) {
		void *ptr = (void *)malloc(size);
		MemChecker::getInstance()->AddTrack((unsigned long)ptr, size, file, line);
		return(ptr);
	};

	inline void __cdecl operator delete[](void *p) {
		MemChecker::getInstance()->RemoveTrack((unsigned long)p);
		free(p);
	};

	#endif



	#ifdef _DEBUG
	#define DEBUG_NEW_ARRAY new[](__FILE__, __LINE__)
	#else
	#define DEBUG_NEW_ARRAY new[]
	#endif
	#undef new[]
	#define new[] DEBUG_NEW_ARRAY[];

#endif // if 0/1

 


#endif  // _NEWOVERLOAD_H

// Some Emacs-Hints -- please don't remove:
//
//  Local Variables:
//  mode:C++
//  tab-width:4
//  End:
