// Title:   my_defs.h
// Created: Thu Sep 25 15:14:43 2003
// Authors: Simon Heinzle, Tim Weyrich
//
// Copyright (c) 2001, 2002, 2003, Computer Graphics Lab, ETH Zurich
//
// This file is part of the Pointshop3D system.
// See http://www.pointshop3d.com/ for more information.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later
// version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General
// Public License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place, Suite 330,
// Boston, MA 02111-1307 USA
// 
// Contact info@pointshop3d.com if any conditions of this
// licensing are not clear to you.
//


#ifndef __MY_DEFS_H
#define __MY_DEFS_H
/**
 * This file includes some useful definitions
 *
 * @author Simon Heinzle
 * @version 1.0
 */
#include "../../../../Core/Scene/src/Scene.h"

/**
 * tPair
 * defines a <code>Vector3D</code> - <code>SurfelInterface*</code> pair.
 */
typedef struct {
	Vector3D newPosition;
	SurfelInterface *oldSurfel;
} tPair;

/**
 * tIndexPositionPair
 * defines a <code>Vector3D</code> - <code>unsigned int</code> pair.
 */
typedef struct {
	Vector3D newPosition;
	unsigned int oldSurfelIndex;
} tIndexPositionPair;

/**
 * tObjectInvTransformationPair
 * defines a <code>Object*</code> - <code>MyDataTypes::TransformationMatrix16f</code> pair.
 */
typedef struct {
	Object *object;
	MyDataTypes::TransformationMatrix16f inverse_transformation;
} tObjectInvTransformationPair;

/**
 * tTransformationPair
 * defines a <code>float[16]</code> - <code>float[16]</code> pair.
 */
typedef struct {
	float transformation[16];
	float inverse_transformation[16];
} tTransformationPair;

/**
 * tIndexObjectPair
 * defines a <code>int</code> - <code>Object*</code> pair.
 */
typedef struct {
	int index;
	Object *object;
} tIndexObjectPair;

#endif
// Some Emacs-Hints -- please don't remove:
//
//  Local Variables:
//  mode:C++
//  tab-width:4
//  End:

// Some Emacs-Hints -- please don't remove:
//
//  Local Variables:
//  mode:C++
//  tab-width:4
//  End:
